/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2001 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/opensrc/NN/src/RCS/TrainNN.p,v 1.2 2002/01/02 08:22:54 sauge Exp $" NO-UNDO.

/* Trains a neural net */

{MakeID3.i}
{default.i}

DEF INPUT PARAMETER cTrainingData AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cName         AS CHARACTER NO-UNDO.

DEF VAR cWord AS CHARACTER NO-UNDO.
DEF VAR iNumWord AS INTEGER NO-UNDO.
DEF VAR iCurWord AS INTEGER NO-UNDO.

/* Pull out a word from the message */

ASSIGN iNumWord = NUM-ENTRIES(cTrainingData, " ").

DO iCurWord = 1 TO iNumWord:

  ASSIGN cWord = ENTRY(iCurWord, cTrainingData, " ").

  /* Determine if a neuron exists for it.  If not, create it. */

  FIND Neuron EXCLUSIVE-LOCK
  WHERE Neuron.Data = cWord
    AND Neuron.Name = cName
  NO-ERROR.

  IF NOT AVAILABLE Neuron THEN DO: 

    CREATE Neuron.
 
    ASSIGN Neuron.NeuronID = MakeID3(10)
           Neuron.Data = cWord
           Neuron.Weight = {&DFLTWEIGHT}
           Neuron.Bias = {&DFLTBIAS}
           Neuron.Layer = {&DFLTLAYER}
           Neuron.Name = cName.

  END. /* IF NOT AVAILABLE Neuron */
  
  /* Train the neuron */

  ELSE 
    Neuron.Weight = Neuron.Weight * {&DFLTTRAIN}.

END. /* DO iCurWord = 1 TO iNumWord */

