/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2001 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/opensrc/NN/src/RCS/UseNN.p,v 1.2 2002/01/02 08:22:54 sauge Exp $" NO-UNDO.

/* Use a NN to classify the input */

DEF INPUT PARAMETER cData              AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cName              AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER lIsClassification AS LOGICAL NO-UNDO.
DEF OUTPUT PARAMETER dTrxFunction      AS DECIMAL NO-UNDO.

DEF VAR iCurWord AS INTEGER NO-UNDO.
DEF VAR iNumWord AS INTEGER NO-UNDO.
DEF VAR cWord    AS CHARACTER NO-UNDO.
DEF VAR E        AS DECIMAL NO-UNDO.

DEF VAR dn           AS DECIMAL NO-UNDO.

{default.i}

/* Default our E */

ASSIGN E = 2.7182818284590452354.

/* Chop up the Data to weed out the words */

ASSIGN iNumWord = NUM-ENTRIES(cData, " ").

DO iCurWord = 1 TO iNumWord:

  ASSIGN cWord = ENTRY(iCurWord, cData, " ").

  /* Find the neuron for this word.  If not available, then move on */

  FIND Neuron NO-LOCK
  WHERE Neuron.Data = cWord
    AND Neuron.Name = cName
  NO-ERROR.

  /* Sigma this across a vector the best we can.  Else yank out */
  /* the default neuron weight for a neuron that is not there.  */

  IF AVAILABLE Neuron THEN 
    ASSIGN dn = dn + Neuron.Weight + Neuron.Bias.
  ELSE
    ASSIGN dn = dn - {&DFLTWEIGHT}.
  

END. /* DO iCurWord = 1 TO iNumWord */

/* Apply the transfer function - currently Log-Sigmoid */

ASSIGN dTrxFunction = 1 / (1 + EXP(E, dn * -1 )).

/* Which side of the threshhold are we? */

ASSIGN lIsClassification = IF dTrxFunction > 0.5 THEN YES ELSE NO.
